"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromAsyncIterable = exports.fromIterable = exports.fromTask = exports.fromLazyArg = void 0;
const G = __importStar(require("./Generator"));
/**
 * @category conversions
 * @since 1.0.0
 */
function fromLazyArg(f) {
    async function* next() {
        const res = f();
        yield res;
    }
    return next();
}
exports.fromLazyArg = fromLazyArg;
/**
 * @category conversions
 * @since 1.0.0
 */
function fromTask(f) {
    async function* next() {
        const res = await f();
        yield res;
    }
    return next();
}
exports.fromTask = fromTask;
/**
 * @category conversions
 * @since 1.0.0
 */
function fromIterable(fa) {
    const g = G.fromIterable(fa);
    async function* next() {
        const next = g.next();
        if (!next.done) {
            yield next.value;
        }
    }
    return next;
}
exports.fromIterable = fromIterable;
/**
 * @category conversions
 * @since 1.0.0
 */
function fromAsyncIterable(fa) {
    async function* next() {
        for await (const a of fa) {
            yield a;
        }
    }
    return next();
}
exports.fromAsyncIterable = fromAsyncIterable;
