import * as G from "./Generator";
/**
 * @category conversions
 * @since 1.0.0
 */
export function fromLazyArg(f) {
    async function* next() {
        const res = f();
        yield res;
    }
    return next();
}
/**
 * @category conversions
 * @since 1.0.0
 */
export function fromTask(f) {
    async function* next() {
        const res = await f();
        yield res;
    }
    return next();
}
/**
 * @category conversions
 * @since 1.0.0
 */
export function fromIterable(fa) {
    const g = G.fromIterable(fa);
    async function* next() {
        const next = g.next();
        if (!next.done) {
            yield next.value;
        }
    }
    return next;
}
/**
 * @category conversions
 * @since 1.0.0
 */
export function fromAsyncIterable(fa) {
    async function* next() {
        for await (const a of fa) {
            yield a;
        }
    }
    return next();
}
